require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_RWSTLOCK_H)) {
    eval 'sub _SYS_RWSTLOCK_H () {1;}' unless defined(&_SYS_RWSTLOCK_H);
    if(defined(&__cplusplus)) {
    }
    require 'sys/types.ph';
    require 'sys/ksynch.ph';
    require 'sys/rwlock.ph';
    eval 'sub RWST_TRYENTER () {0x1;}' unless defined(&RWST_TRYENTER);
    eval 'sub RWST_SIG () {0x2;}' unless defined(&RWST_SIG);
    eval 'sub RWST_HELD {
        my($l) = @_;
	    eval q((($l)-> &rwst_count != 0));
    }' unless defined(&RWST_HELD);
    eval 'sub RWST_READ_HELD {
        my($l) = @_;
	    eval q((($l)-> &rwst_count > 0));
    }' unless defined(&RWST_READ_HELD);
    eval 'sub RWST_WRITE_HELD {
        my($l) = @_;
	    eval q((($l)-> &rwst_count < 0));
    }' unless defined(&RWST_WRITE_HELD);
    eval 'sub RWST_WRITE_OWNER {
        my($l) = @_;
	    eval q((($l)-> &rwst_count == ( &LONG_MIN | ( &intptr_t) &curthread)));
    }' unless defined(&RWST_WRITE_OWNER);
    eval 'sub RWST_OWNER {
        my($l) = @_;
	    eval q(( &RWST_WRITE_HELD($l) ? ((($l)-> &rwst_count & ~ &LONG_MIN)) :  &NULL));
    }' unless defined(&RWST_OWNER);
    eval 'sub RWST_READ_WANTED {
        my($l) = @_;
	    eval q( &CV_HAS_WAITERS(($l)-> &rwst_rcv));
    }' unless defined(&RWST_READ_WANTED);
    eval 'sub RWST_WRITE_WANTED {
        my($l) = @_;
	    eval q( &CV_HAS_WAITERS(($l)-> &rwst_wcv));
    }' unless defined(&RWST_WRITE_WANTED);
    eval 'sub RWST_WAIT {
        my($cv, $lock, $f) = @_;
	    eval q((($f) &  &RWST_SIG ?  &cv_wait_sig($cv, $lock) : ( &cv_wait($cv, $lock), 1)));
    }' unless defined(&RWST_WAIT);
    eval 'sub RWST_READ_WAIT {
        my($l, $f) = @_;
	    eval q( &RWST_WAIT(($l)-> &rwst_rcv, ($l)-> &rwst_lock, $f));
    }' unless defined(&RWST_READ_WAIT);
    eval 'sub RWST_WRITE_WAIT {
        my($l, $f) = @_;
	    eval q( &RWST_WAIT(($l)-> &rwst_wcv, ($l)-> &rwst_lock, $f));
    }' unless defined(&RWST_WRITE_WAIT);
    eval 'sub RWST_READ_WAKE_ALL {
        my($l) = @_;
	    eval q( &cv_broadcast(($l)-> &rwst_rcv));
    }' unless defined(&RWST_READ_WAKE_ALL);
    eval 'sub RWST_WRITE_WAKE_ONE {
        my($l) = @_;
	    eval q( &cv_signal(($l)-> &rwst_wcv));
    }' unless defined(&RWST_WRITE_WAKE_ONE);
    eval 'sub RWST_READ_ENTER {
        my($l) = @_;
	    eval q(($l)-> &rwst_count++);
    }' unless defined(&RWST_READ_ENTER);
    eval 'sub RWST_WRITE_ENTER {
        my($l) = @_;
	    eval q(($l)-> &rwst_count =  &LONG_MIN | ( &intptr_t) &curthread);
    }' unless defined(&RWST_WRITE_ENTER);
    eval 'sub RWST_READ_EXIT {
        my($l) = @_;
	    eval q(($l)-> &rwst_count--);
    }' unless defined(&RWST_READ_EXIT);
    eval 'sub RWST_WRITE_EXIT {
        my($l) = @_;
	    eval q(($l)-> &rwst_count = 0);
    }' unless defined(&RWST_WRITE_EXIT);
    if(defined(&__cplusplus)) {
    }
}
1;
