require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_VNODE_H)) {
    eval 'sub _SYS_VNODE_H () {1;}' unless defined(&_SYS_VNODE_H);
    require 'sys/types.ph';
    require 'sys/t_lock.ph';
    require 'sys/rwstlock.ph';
    require 'sys/time_impl.ph';
    require 'sys/cred.ph';
    require 'sys/uio.ph';
    require 'sys/resource.ph';
    require 'vm/seg_enum.ph';
    require 'sys/kstat.ph';
    require 'sys/kmem.ph';
    require 'sys/list.ph';
    if(defined(&_KERNEL)) {
	require 'sys/buf.ph';
    }
    if(defined(&__cplusplus)) {
    }
    eval 'sub VOPSTATS_STR () {"vopstats_";}' unless defined(&VOPSTATS_STR);
    eval("sub VNON () { 0; }") unless defined(&VNON);
    eval("sub VREG () { 1; }") unless defined(&VREG);
    eval("sub VDIR () { 2; }") unless defined(&VDIR);
    eval("sub VBLK () { 3; }") unless defined(&VBLK);
    eval("sub VCHR () { 4; }") unless defined(&VCHR);
    eval("sub VLNK () { 5; }") unless defined(&VLNK);
    eval("sub VFIFO () { 6; }") unless defined(&VFIFO);
    eval("sub VDOOR () { 7; }") unless defined(&VDOOR);
    eval("sub VPROC () { 8; }") unless defined(&VPROC);
    eval("sub VSOCK () { 9; }") unless defined(&VSOCK);
    eval("sub VPORT () { 10; }") unless defined(&VPORT);
    eval("sub VBAD () { 11; }") unless defined(&VBAD);
    eval 'sub IS_DEVVP {
        my($vp) = @_;
	    eval q((($vp)-> &v_type ==  &VCHR || ($vp)-> &v_type ==  &VBLK || ($vp)-> &v_type ==  &VFIFO));
    }' unless defined(&IS_DEVVP);
    eval 'sub VROOT () {0x1;}' unless defined(&VROOT);
    eval 'sub VNOCACHE () {0x2;}' unless defined(&VNOCACHE);
    eval 'sub VNOMAP () {0x4;}' unless defined(&VNOMAP);
    eval 'sub VDUP () {0x8;}' unless defined(&VDUP);
    eval 'sub VNOSWAP () {0x10;}' unless defined(&VNOSWAP);
    eval 'sub VNOMOUNT () {0x20;}' unless defined(&VNOMOUNT);
    eval 'sub VISSWAP () {0x40;}' unless defined(&VISSWAP);
    eval 'sub VSWAPLIKE () {0x80;}' unless defined(&VSWAPLIKE);
    eval 'sub IS_SWAPVP {
        my($vp) = @_;
	    eval q(((($vp)-> &v_flag & ( &VISSWAP |  &VSWAPLIKE)) != 0));
    }' unless defined(&IS_SWAPVP);
    eval 'sub VVFSLOCK () {0x100;}' unless defined(&VVFSLOCK);
    eval 'sub VVFSWAIT () {0x200;}' unless defined(&VVFSWAIT);
    eval 'sub VVMLOCK () {0x400;}' unless defined(&VVMLOCK);
    eval 'sub VDIROPEN () {0x800;}' unless defined(&VDIROPEN);
    eval 'sub VVMEXEC () {0x1000;}' unless defined(&VVMEXEC);
    eval 'sub VPXFS () {0x2000;}' unless defined(&VPXFS);
    eval 'sub IS_PXFSVP {
        my($vp) = @_;
	    eval q((($vp)-> &v_flag &  &VPXFS));
    }' unless defined(&IS_PXFSVP);
    eval 'sub V_XATTRDIR () {0x4000;}' unless defined(&V_XATTRDIR);
    eval 'sub V_LOCALITY () {0x8000;}' unless defined(&V_LOCALITY);
    eval 'sub VMODSORT () {(0x10000);}' unless defined(&VMODSORT);
    eval 'sub IS_VMODSORT {
        my($vp) = @_;
	    eval q(( &pvn_vmodsort_supported != 0 && (($vp)-> &v_flag &  &VMODSORT) != 0));
    }' unless defined(&IS_VMODSORT);
    eval 'sub VISSWAPFS () {0x20000;}' unless defined(&VISSWAPFS);
    eval 'sub IS_SWAPFSVP {
        my($vp) = @_;
	    eval q(((($vp)-> &v_flag &  &VISSWAPFS) != 0));
    }' unless defined(&IS_SWAPFSVP);
    eval 'sub V_SYSATTR () {0x40000;}' unless defined(&V_SYSATTR);
    eval 'sub AV_SCANSTAMP_SZ () {32;}' unless defined(&AV_SCANSTAMP_SZ);
    eval 'sub XVA_MAPSIZE () {3;}' unless defined(&XVA_MAPSIZE);
    eval 'sub XVA_MAGIC () {0x78766174;}' unless defined(&XVA_MAGIC);
    if(defined(&_SYSCALL32)) {
	if((defined(&_LONG_LONG_ALIGNMENT) ? &_LONG_LONG_ALIGNMENT : undef) == 8 && (defined(&_LONG_LONG_ALIGNMENT_32) ? &_LONG_LONG_ALIGNMENT_32 : undef) == 4) {
	}
	if((defined(&_LONG_LONG_ALIGNMENT) ? &_LONG_LONG_ALIGNMENT : undef) == 8 && (defined(&_LONG_LONG_ALIGNMENT_32) ? &_LONG_LONG_ALIGNMENT_32 : undef) == 4) {
	}
    } else {
	eval 'sub vattr32 () { &vattr;}' unless defined(&vattr32);
    }
    eval 'sub AT_TYPE () {0x1;}' unless defined(&AT_TYPE);
    eval 'sub AT_MODE () {0x2;}' unless defined(&AT_MODE);
    eval 'sub AT_UID () {0x4;}' unless defined(&AT_UID);
    eval 'sub AT_GID () {0x8;}' unless defined(&AT_GID);
    eval 'sub AT_FSID () {0x10;}' unless defined(&AT_FSID);
    eval 'sub AT_NODEID () {0x20;}' unless defined(&AT_NODEID);
    eval 'sub AT_NLINK () {0x40;}' unless defined(&AT_NLINK);
    eval 'sub AT_SIZE () {0x80;}' unless defined(&AT_SIZE);
    eval 'sub AT_ATIME () {0x100;}' unless defined(&AT_ATIME);
    eval 'sub AT_MTIME () {0x200;}' unless defined(&AT_MTIME);
    eval 'sub AT_CTIME () {0x400;}' unless defined(&AT_CTIME);
    eval 'sub AT_RDEV () {0x800;}' unless defined(&AT_RDEV);
    eval 'sub AT_BLKSIZE () {0x1000;}' unless defined(&AT_BLKSIZE);
    eval 'sub AT_NBLOCKS () {0x2000;}' unless defined(&AT_NBLOCKS);
    eval 'sub AT_SEQ () {0x8000;}' unless defined(&AT_SEQ);
    eval 'sub AT_XVATTR () {0x10000;}' unless defined(&AT_XVATTR);
    eval 'sub AT_ALL () {( &AT_TYPE| &AT_MODE| &AT_UID| &AT_GID| &AT_FSID| &AT_NODEID|  &AT_NLINK| &AT_SIZE| &AT_ATIME| &AT_MTIME| &AT_CTIME|  &AT_RDEV| &AT_BLKSIZE| &AT_NBLOCKS| &AT_SEQ);}' unless defined(&AT_ALL);
    eval 'sub AT_STAT () {( &AT_MODE| &AT_UID| &AT_GID| &AT_FSID| &AT_NODEID| &AT_NLINK|  &AT_SIZE| &AT_ATIME| &AT_MTIME| &AT_CTIME| &AT_RDEV| &AT_TYPE);}' unless defined(&AT_STAT);
    eval 'sub AT_TIMES () {( &AT_ATIME| &AT_MTIME| &AT_CTIME);}' unless defined(&AT_TIMES);
    eval 'sub AT_NOSET () {( &AT_NLINK| &AT_RDEV| &AT_FSID| &AT_NODEID| &AT_TYPE|  &AT_BLKSIZE| &AT_NBLOCKS| &AT_SEQ);}' unless defined(&AT_NOSET);
    eval 'sub XAT0_INDEX () {0;}' unless defined(&XAT0_INDEX);
    eval 'sub XAT0_CREATETIME () {0x1;}' unless defined(&XAT0_CREATETIME);
    eval 'sub XAT0_ARCHIVE () {0x2;}' unless defined(&XAT0_ARCHIVE);
    eval 'sub XAT0_SYSTEM () {0x4;}' unless defined(&XAT0_SYSTEM);
    eval 'sub XAT0_READONLY () {0x8;}' unless defined(&XAT0_READONLY);
    eval 'sub XAT0_HIDDEN () {0x10;}' unless defined(&XAT0_HIDDEN);
    eval 'sub XAT0_NOUNLINK () {0x20;}' unless defined(&XAT0_NOUNLINK);
    eval 'sub XAT0_IMMUTABLE () {0x40;}' unless defined(&XAT0_IMMUTABLE);
    eval 'sub XAT0_APPENDONLY () {0x80;}' unless defined(&XAT0_APPENDONLY);
    eval 'sub XAT0_NODUMP () {0x100;}' unless defined(&XAT0_NODUMP);
    eval 'sub XAT0_OPAQUE () {0x200;}' unless defined(&XAT0_OPAQUE);
    eval 'sub XAT0_AV_QUARANTINED () {0x400;}' unless defined(&XAT0_AV_QUARANTINED);
    eval 'sub XAT0_AV_MODIFIED () {0x800;}' unless defined(&XAT0_AV_MODIFIED);
    eval 'sub XAT0_AV_SCANSTAMP () {0x1000;}' unless defined(&XAT0_AV_SCANSTAMP);
    eval 'sub XAT0_ALL_ATTRS () {( &XAT0_CREATETIME| &XAT0_ARCHIVE| &XAT0_SYSTEM|  &XAT0_READONLY| &XAT0_HIDDEN| &XAT0_NOUNLINK| &XAT0_IMMUTABLE| &XAT0_APPENDONLY|  &XAT0_NODUMP| &XAT0_OPAQUE| &XAT0_AV_QUARANTINED|  &XAT0_AV_MODIFIED| &XAT0_AV_SCANSTAMP);}' unless defined(&XAT0_ALL_ATTRS);
    eval 'sub XVA_MASK () {0xffffffff;}' unless defined(&XVA_MASK);
    eval 'sub XVA_SHFT () {32;}' unless defined(&XVA_SHFT);
    eval 'sub XVA_INDEX {
        my($attr) = @_;
	    eval q((( &uint32_t)((($attr) >>  &XVA_SHFT) &  &XVA_MASK)));
    }' unless defined(&XVA_INDEX);
    eval 'sub XVA_ATTRBIT {
        my($attr) = @_;
	    eval q((( &uint32_t)(($attr) &  &XVA_MASK)));
    }' unless defined(&XVA_ATTRBIT);
    eval 'sub XAT_CREATETIME () {(( &XAT0_INDEX <<  &XVA_SHFT) |  &XAT0_CREATETIME);}' unless defined(&XAT_CREATETIME);
    eval 'sub XAT_ARCHIVE () {(( &XAT0_INDEX <<  &XVA_SHFT) |  &XAT0_ARCHIVE);}' unless defined(&XAT_ARCHIVE);
    eval 'sub XAT_SYSTEM () {(( &XAT0_INDEX <<  &XVA_SHFT) |  &XAT0_SYSTEM);}' unless defined(&XAT_SYSTEM);
    eval 'sub XAT_READONLY () {(( &XAT0_INDEX <<  &XVA_SHFT) |  &XAT0_READONLY);}' unless defined(&XAT_READONLY);
    eval 'sub XAT_HIDDEN () {(( &XAT0_INDEX <<  &XVA_SHFT) |  &XAT0_HIDDEN);}' unless defined(&XAT_HIDDEN);
    eval 'sub XAT_NOUNLINK () {(( &XAT0_INDEX <<  &XVA_SHFT) |  &XAT0_NOUNLINK);}' unless defined(&XAT_NOUNLINK);
    eval 'sub XAT_IMMUTABLE () {(( &XAT0_INDEX <<  &XVA_SHFT) |  &XAT0_IMMUTABLE);}' unless defined(&XAT_IMMUTABLE);
    eval 'sub XAT_APPENDONLY () {(( &XAT0_INDEX <<  &XVA_SHFT) |  &XAT0_APPENDONLY);}' unless defined(&XAT_APPENDONLY);
    eval 'sub XAT_NODUMP () {(( &XAT0_INDEX <<  &XVA_SHFT) |  &XAT0_NODUMP);}' unless defined(&XAT_NODUMP);
    eval 'sub XAT_OPAQUE () {(( &XAT0_INDEX <<  &XVA_SHFT) |  &XAT0_OPAQUE);}' unless defined(&XAT_OPAQUE);
    eval 'sub XAT_AV_QUARANTINED () {(( &XAT0_INDEX <<  &XVA_SHFT) |  &XAT0_AV_QUARANTINED);}' unless defined(&XAT_AV_QUARANTINED);
    eval 'sub XAT_AV_MODIFIED () {(( &XAT0_INDEX <<  &XVA_SHFT) |  &XAT0_AV_MODIFIED);}' unless defined(&XAT_AV_MODIFIED);
    eval 'sub XAT_AV_SCANSTAMP () {(( &XAT0_INDEX <<  &XVA_SHFT) |  &XAT0_AV_SCANSTAMP);}' unless defined(&XAT_AV_SCANSTAMP);
    eval 'sub XVA_RTNATTRMAP {
        my($xvap) = @_;
	    eval q((($xvap)-> &xva_rtnattrmapp));
    }' unless defined(&XVA_RTNATTRMAP);
    eval 'sub XVA_SET_REQ {
        my($xvap, $attr) = @_;
	    eval q( &ASSERT(($xvap)-> ($xva_vattr->{va_mask}) |  &AT_XVATTR);  &ASSERT(($xvap)-> &xva_magic ==  &XVA_MAGIC); ($xvap)-> $xva_reqattrmap[ &XVA_INDEX($attr)] |=  &XVA_ATTRBIT($attr));
    }' unless defined(&XVA_SET_REQ);
    eval 'sub XVA_SET_RTN {
        my($xvap, $attr) = @_;
	    eval q( &ASSERT(($xvap)-> ($xva_vattr->{va_mask}) |  &AT_XVATTR);  &ASSERT(($xvap)-> &xva_magic ==  &XVA_MAGIC); ( &XVA_RTNATTRMAP($xvap))[ &XVA_INDEX($attr)] |=  &XVA_ATTRBIT($attr));
    }' unless defined(&XVA_SET_RTN);
    eval 'sub XVA_ISSET_REQ {
        my($xvap, $attr) = @_;
	    eval q((((($xvap)-> ($xva_vattr->{va_mask}) |  &AT_XVATTR)  && (($xvap)-> &xva_magic ==  &XVA_MAGIC)  && (($xvap)-> &xva_mapsize >  &XVA_INDEX($attr))) ? (($xvap)-> $xva_reqattrmap[ &XVA_INDEX($attr)] &  &XVA_ATTRBIT($attr)) : 0));
    }' unless defined(&XVA_ISSET_REQ);
    eval 'sub XVA_ISSET_RTN {
        my($xvap, $attr) = @_;
	    eval q((((($xvap)-> ($xva_vattr->{va_mask}) |  &AT_XVATTR)  && (($xvap)-> &xva_magic ==  &XVA_MAGIC)  && (($xvap)-> &xva_mapsize >  &XVA_INDEX($attr))) ? (( &XVA_RTNATTRMAP($xvap))[ &XVA_INDEX($attr)] &  &XVA_ATTRBIT($attr)) : 0));
    }' unless defined(&XVA_ISSET_RTN);
    eval 'sub VSUID () {04000;}' unless defined(&VSUID);
    eval 'sub VSGID () {02000;}' unless defined(&VSGID);
    eval 'sub VSVTX () {01000;}' unless defined(&VSVTX);
    eval 'sub VREAD () {00400;}' unless defined(&VREAD);
    eval 'sub VWRITE () {00200;}' unless defined(&VWRITE);
    eval 'sub VEXEC () {00100;}' unless defined(&VEXEC);
    eval 'sub MODEMASK () {07777;}' unless defined(&MODEMASK);
    eval 'sub PERMMASK () {00777;}' unless defined(&PERMMASK);
    eval 'sub V_ACE_MASK () {0x1;}' unless defined(&V_ACE_MASK);
    eval 'sub V_APPEND () {0x2;}' unless defined(&V_APPEND);
    eval 'sub MANDMODE {
        my($mode) = @_;
	    eval q(((($mode) & ( &VSGID|( &VEXEC>>3))) ==  &VSGID));
    }' unless defined(&MANDMODE);
    eval 'sub MANDLOCK {
        my($vp, $mode) = @_;
	    eval q((($vp)-> &v_type ==  &VREG  &&  &MANDMODE($mode)));
    }' unless defined(&MANDLOCK);
    eval("sub RMFILE () { 0; }") unless defined(&RMFILE);
    eval("sub RMDIRECTORY () { 1; }") unless defined(&RMDIRECTORY);
    eval("sub NO_FOLLOW () { 0; }") unless defined(&NO_FOLLOW);
    eval("sub FOLLOW () { 1; }") unless defined(&FOLLOW);
    eval("sub NONEXCL () { 0; }") unless defined(&NONEXCL);
    eval("sub EXCL () { 1; }") unless defined(&EXCL);
    eval("sub CRCREAT () { 0; }") unless defined(&CRCREAT);
    eval("sub CRMKNOD () { 1; }") unless defined(&CRMKNOD);
    eval("sub CRMKDIR () { 2; }") unless defined(&CRMKDIR);
    eval("sub VE_SUPPORT () { 0; }") unless defined(&VE_SUPPORT);
    eval("sub VE_RENAME_SRC () { 1; }") unless defined(&VE_RENAME_SRC);
    eval("sub VE_RENAME_DEST () { 2; }") unless defined(&VE_RENAME_DEST);
    eval("sub VE_REMOVE () { 3; }") unless defined(&VE_REMOVE);
    eval("sub VE_RMDIR () { 4; }") unless defined(&VE_RMDIR);
    eval("sub VE_CREATE () { 5; }") unless defined(&VE_CREATE);
    eval("sub VE_LINK () { 6; }") unless defined(&VE_LINK);
    eval("sub VE_RENAME_DEST_DIR () { 7; }") unless defined(&VE_RENAME_DEST_DIR);
    eval("sub VE_MOUNTEDOVER () { 8; }") unless defined(&VE_MOUNTEDOVER);
    eval("sub V_READ () { 0; }") unless defined(&V_READ);
    eval("sub V_WRITE () { 1; }") unless defined(&V_WRITE);
    eval("sub V_RDORWR () { 2; }") unless defined(&V_RDORWR);
    eval("sub V_RDANDWR () { 3; }") unless defined(&V_RDANDWR);
    eval 'sub V_TRUE () {1;}' unless defined(&V_TRUE);
    eval 'sub V_FALSE () {0;}' unless defined(&V_FALSE);
    eval 'sub VSA_ACL () {0x1;}' unless defined(&VSA_ACL);
    eval 'sub VSA_ACLCNT () {0x2;}' unless defined(&VSA_ACLCNT);
    eval 'sub VSA_DFACL () {0x4;}' unless defined(&VSA_DFACL);
    eval 'sub VSA_DFACLCNT () {0x8;}' unless defined(&VSA_DFACLCNT);
    eval 'sub VSA_ACE () {0x10;}' unless defined(&VSA_ACE);
    eval 'sub VSA_ACECNT () {0x20;}' unless defined(&VSA_ACECNT);
    eval 'sub VSA_ACE_ALLTYPES () {0x40;}' unless defined(&VSA_ACE_ALLTYPES);
    eval 'sub VSA_ACE_ACLFLAGS () {0x80;}' unless defined(&VSA_ACE_ACLFLAGS);
    eval 'sub CC_WOULDBLOCK () {0x1;}' unless defined(&CC_WOULDBLOCK);
    eval 'sub CC_DONTBLOCK () {0x2;}' unless defined(&CC_DONTBLOCK);
    if(defined(&_KERNEL)) {
	eval 'sub VNODE_OPS () { &int (* &vop_open)( &vnode_t **, \'int\',  &cred_t *,  &caller_context_t *);  &int (* &vop_close)( &vnode_t *, \'int\', \'int\',  &offset_t,  &cred_t *,  &caller_context_t *);  &int (* &vop_read)( &vnode_t *,  &uio_t *, \'int\',  &cred_t *,  &caller_context_t *);  &int (* &vop_write)( &vnode_t *,  &uio_t *, \'int\',  &cred_t *,  &caller_context_t *);  &int (* &vop_ioctl)( &vnode_t *, \'int\',  &intptr_t, \'int\',  &cred_t *, \'int\' *,  &caller_context_t *);  &int (* &vop_setfl)( &vnode_t *, \'int\', \'int\',  &cred_t *,  &caller_context_t *);  &int (* &vop_getattr)( &vnode_t *,  &vattr_t *, \'int\',  &cred_t *,  &caller_context_t *);  &int (* &vop_setattr)( &vnode_t *,  &vattr_t *, \'int\',  &cred_t *,  &caller_context_t *);  &int (* &vop_access)( &vnode_t *, \'int\', \'int\',  &cred_t *,  &caller_context_t *);  &int (* &vop_lookup)( &vnode_t *, \'char\' *,  &vnode_t **, 1;  &int (* &vop_create)( &vnode_t *, \'char\' *,  &vattr_t *,  &vcexcl_t, \'int\',  &vnode_t **,  &cred_t *, \'int\',  &caller_context_t *,  &vsecattr_t *);  &int (* &vop_remove)( &vnode_t *, \'char\' *,  &cred_t *,  &caller_context_t *, \'int\');  &int (* &vop_link)( &vnode_t *,  &vnode_t *, \'char\' *,  &cred_t *,  &caller_context_t *, \'int\');  &int (* &vop_rename)( &vnode_t *, \'char\' *,  &vnode_t *, \'char\' *,  &cred_t *,  &caller_context_t *, \'int\');  &int (* &vop_mkdir)( &vnode_t *, \'char\' *,  &vattr_t *,  &vnode_t **,  &cred_t *,  &caller_context_t *, \'int\',  &vsecattr_t *);  &int (* &vop_rmdir)( &vnode_t *, \'char\' *,  &vnode_t *,  &cred_t *,  &caller_context_t *, \'int\');  &int (* &vop_readdir)( &vnode_t *,  &uio_t *,  &cred_t *, \'int\' *,  &caller_context_t *, \'int\');  &int (* &vop_symlink)( &vnode_t *, \'char\' *,  &vattr_t *, \'char\' *,  &cred_t *,  &caller_context_t *, \'int\');  &int (* &vop_readlink)( &vnode_t *,  &uio_t *,  &cred_t *,  &caller_context_t *);  &int (* &vop_fsync)( &vnode_t *, \'int\',  &cred_t *,  &caller_context_t *);  &void (* &vop_inactive)( &vnode_t *,  &cred_t *,  &caller_context_t *);  &int (* &vop_fid)( &vnode_t *, 1;  &int (* &vop_rwlock)( &vnode_t *, \'int\',  &caller_context_t *);  &void (* &vop_rwunlock)( &vnode_t *, \'int\',  &caller_context_t *);  &int (* &vop_seek)( &vnode_t *,  &offset_t,  &offset_t *,  &caller_context_t *);  &int (* &vop_cmp)( &vnode_t *,  &vnode_t *,  &caller_context_t *);  &int (* &vop_frlock)( &vnode_t *, \'int\', 1;  &int (* &vop_space)( &vnode_t *, \'int\', 1;  &int (* &vop_realvp)( &vnode_t *,  &vnode_t **,  &caller_context_t *);  &int (* &vop_getpage)( &vnode_t *,  &offset_t, \'size_t\',  &uint_t *, 1;  &int (* &vop_putpage)( &vnode_t *,  &offset_t, \'size_t\', \'int\',  &cred_t *,  &caller_context_t *);  &int (* &vop_map)( &vnode_t *,  &offset_t, 1;  &int (* &vop_addmap)( &vnode_t *,  &offset_t, 1;  &int (* &vop_delmap)( &vnode_t *,  &offset_t, 1;  &int (* &vop_poll)( &vnode_t *, \'short\', \'int\', \'short\' *, 1;  &int (* &vop_dump)( &vnode_t *, \'caddr_t\', \'int\', \'int\',  &caller_context_t *);  &int (* &vop_pathconf)( &vnode_t *, \'int\', \'ulong_t\' *,  &cred_t *,  &caller_context_t *);  &int (* &vop_pageio)( &vnode_t *, 1;  &int (* &vop_dumpctl)( &vnode_t *, \'int\', \'int\' *,  &caller_context_t *);  &void (* &vop_dispose)( &vnode_t *, 1;  &int (* &vop_setsecattr)( &vnode_t *,  &vsecattr_t *, \'int\',  &cred_t *,  &caller_context_t *);  &int (* &vop_getsecattr)( &vnode_t *,  &vsecattr_t *, \'int\',  &cred_t *,  &caller_context_t *);  &int (* &vop_shrlock)( &vnode_t *, \'int\', 1;  &int (* &vop_vnevent)( &vnode_t *,  &vnevent_t,  &vnode_t *, \'char\' *,  &caller_context_t *);}' unless defined(&VNODE_OPS);
    }
    eval 'sub VOP_OPEN {
        my($vpp, $mode, $cr, $ct) = @_;
	    eval q( &fop_open($vpp, $mode, $cr, $ct));
    }' unless defined(&VOP_OPEN);
    eval 'sub VOP_CLOSE {
        my($vp, $f, $c, $o, $cr, $ct) = @_;
	    eval q( &fop_close($vp, $f, $c, $o, $cr, $ct));
    }' unless defined(&VOP_CLOSE);
    eval 'sub VOP_READ {
        my($vp, $uiop, $iof, $cr, $ct) = @_;
	    eval q( &fop_read($vp, $uiop, $iof, $cr, $ct));
    }' unless defined(&VOP_READ);
    eval 'sub VOP_WRITE {
        my($vp, $uiop, $iof, $cr, $ct) = @_;
	    eval q( &fop_write($vp, $uiop, $iof, $cr, $ct));
    }' unless defined(&VOP_WRITE);
    eval 'sub VOP_IOCTL {
        my($vp, $cmd, $a, $f, $cr, $rvp, $ct) = @_;
	    eval q( &fop_ioctl($vp, $cmd, $a, $f, $cr, $rvp, $ct));
    }' unless defined(&VOP_IOCTL);
    eval 'sub VOP_SETFL {
        my($vp, $f, $a, $cr, $ct) = @_;
	    eval q( &fop_setfl($vp, $f, $a, $cr, $ct));
    }' unless defined(&VOP_SETFL);
    eval 'sub VOP_GETATTR {
        my($vp, $vap, $f, $cr, $ct) = @_;
	    eval q( &fop_getattr($vp, $vap, $f, $cr, $ct));
    }' unless defined(&VOP_GETATTR);
    eval 'sub VOP_SETATTR {
        my($vp, $vap, $f, $cr, $ct) = @_;
	    eval q( &fop_setattr($vp, $vap, $f, $cr, $ct));
    }' unless defined(&VOP_SETATTR);
    eval 'sub VOP_ACCESS {
        my($vp, $mode, $f, $cr, $ct) = @_;
	    eval q( &fop_access($vp, $mode, $f, $cr, $ct));
    }' unless defined(&VOP_ACCESS);
    eval 'sub VOP_LOOKUP {
        my($vp, $cp, $vpp, $pnp, $f, $rdir, $cr, $ct, $defp, $rpnp) = @_;
	    eval q( &fop_lookup($vp, $cp, $vpp, $pnp, $f, $rdir, $cr, $ct, $defp, $rpnp));
    }' unless defined(&VOP_LOOKUP);
    eval 'sub VOP_CREATE {
        my($dvp, $p, $vap, $ex, $mode, $vpp, $cr, $flag, $ct, $vsap) = @_;
	    eval q( &fop_create($dvp, $p, $vap, $ex, $mode, $vpp, $cr, $flag, $ct, $vsap));
    }' unless defined(&VOP_CREATE);
    eval 'sub VOP_REMOVE {
        my($dvp, $p, $cr, $ct, $f) = @_;
	    eval q( &fop_remove($dvp, $p, $cr, $ct, $f));
    }' unless defined(&VOP_REMOVE);
    eval 'sub VOP_LINK {
        my($tdvp, $fvp, $p, $cr, $ct, $f) = @_;
	    eval q( &fop_link($tdvp, $fvp, $p, $cr, $ct, $f));
    }' unless defined(&VOP_LINK);
    eval 'sub VOP_RENAME {
        my($fvp, $fnm, $tdvp, $tnm, $cr, $ct, $f) = @_;
	    eval q( &fop_rename($fvp, $fnm, $tdvp, $tnm, $cr, $ct, $f));
    }' unless defined(&VOP_RENAME);
    eval 'sub VOP_MKDIR {
        my($dp, $p, $vap, $vpp, $cr, $ct, $f, $vsap) = @_;
	    eval q( &fop_mkdir($dp, $p, $vap, $vpp, $cr, $ct, $f, $vsap));
    }' unless defined(&VOP_MKDIR);
    eval 'sub VOP_RMDIR {
        my($dp, $p, $cdir, $cr, $ct, $f) = @_;
	    eval q( &fop_rmdir($dp, $p, $cdir, $cr, $ct, $f));
    }' unless defined(&VOP_RMDIR);
    eval 'sub VOP_READDIR {
        my($vp, $uiop, $cr, $eofp, $ct, $f) = @_;
	    eval q( &fop_readdir($vp, $uiop, $cr, $eofp, $ct, $f));
    }' unless defined(&VOP_READDIR);
    eval 'sub VOP_SYMLINK {
        my($dvp, $lnm, $vap, $tnm, $cr, $ct, $f) = @_;
	    eval q( &fop_symlink($dvp, $lnm, $vap, $tnm, $cr, $ct, $f));
    }' unless defined(&VOP_SYMLINK);
    eval 'sub VOP_READLINK {
        my($vp, $uiop, $cr, $ct) = @_;
	    eval q( &fop_readlink($vp, $uiop, $cr, $ct));
    }' unless defined(&VOP_READLINK);
    eval 'sub VOP_FSYNC {
        my($vp, $syncflag, $cr, $ct) = @_;
	    eval q( &fop_fsync($vp, $syncflag, $cr, $ct));
    }' unless defined(&VOP_FSYNC);
    eval 'sub VOP_INACTIVE {
        my($vp, $cr, $ct) = @_;
	    eval q( &fop_inactive($vp, $cr, $ct));
    }' unless defined(&VOP_INACTIVE);
    eval 'sub VOP_FID {
        my($vp, $fidp, $ct) = @_;
	    eval q( &fop_fid($vp, $fidp, $ct));
    }' unless defined(&VOP_FID);
    eval 'sub VOP_RWLOCK {
        my($vp, $w, $ct) = @_;
	    eval q( &fop_rwlock($vp, $w, $ct));
    }' unless defined(&VOP_RWLOCK);
    eval 'sub VOP_RWUNLOCK {
        my($vp, $w, $ct) = @_;
	    eval q( &fop_rwunlock($vp, $w, $ct));
    }' unless defined(&VOP_RWUNLOCK);
    eval 'sub VOP_SEEK {
        my($vp, $ooff, $noffp, $ct) = @_;
	    eval q( &fop_seek($vp, $ooff, $noffp, $ct));
    }' unless defined(&VOP_SEEK);
    eval 'sub VOP_CMP {
        my($vp1, $vp2, $ct) = @_;
	    eval q( &fop_cmp($vp1, $vp2, $ct));
    }' unless defined(&VOP_CMP);
    eval 'sub VOP_FRLOCK {
        my($vp, $cmd, $a, $f, $o, $cb, $cr, $ct) = @_;
	    eval q( &fop_frlock($vp, $cmd, $a, $f, $o, $cb, $cr, $ct));
    }' unless defined(&VOP_FRLOCK);
    eval 'sub VOP_SPACE {
        my($vp, $cmd, $a, $f, $o, $cr, $ct) = @_;
	    eval q( &fop_space($vp, $cmd, $a, $f, $o, $cr, $ct));
    }' unless defined(&VOP_SPACE);
    eval 'sub VOP_REALVP {
        my($vp1, $vp2, $ct) = @_;
	    eval q( &fop_realvp($vp1, $vp2, $ct));
    }' unless defined(&VOP_REALVP);
    eval 'sub VOP_GETPAGE {
        my($vp, $of, $sz, $pr, $pl, $ps, $sg, $a, $rw, $cr, $ct) = @_;
	    eval q( &fop_getpage($vp, $of, $sz, $pr, $pl, $ps, $sg, $a, $rw, $cr, $ct));
    }' unless defined(&VOP_GETPAGE);
    eval 'sub VOP_PUTPAGE {
        my($vp, $of, $sz, $fl, $cr, $ct) = @_;
	    eval q( &fop_putpage($vp, $of, $sz, $fl, $cr, $ct));
    }' unless defined(&VOP_PUTPAGE);
    eval 'sub VOP_MAP {
        my($vp, $of, $as, $a, $sz, $p, $mp, $fl, $cr, $ct) = @_;
	    eval q( &fop_map($vp, $of, $as, $a, $sz, $p, $mp, $fl, $cr, $ct));
    }' unless defined(&VOP_MAP);
    eval 'sub VOP_ADDMAP {
        my($vp, $of, $as, $a, $sz, $p, $mp, $fl, $cr, $ct) = @_;
	    eval q( &fop_addmap($vp, $of, $as, $a, $sz, $p, $mp, $fl, $cr, $ct));
    }' unless defined(&VOP_ADDMAP);
    eval 'sub VOP_DELMAP {
        my($vp, $of, $as, $a, $sz, $p, $mp, $fl, $cr, $ct) = @_;
	    eval q( &fop_delmap($vp, $of, $as, $a, $sz, $p, $mp, $fl, $cr, $ct));
    }' unless defined(&VOP_DELMAP);
    eval 'sub VOP_POLL {
        my($vp, $events, $anyyet, $reventsp, $phpp, $ct) = @_;
	    eval q( &fop_poll($vp, $events, $anyyet, $reventsp, $phpp, $ct));
    }' unless defined(&VOP_POLL);
    eval 'sub VOP_DUMP {
        my($vp, $addr, $bn, $count, $ct) = @_;
	    eval q( &fop_dump($vp, $addr, $bn, $count, $ct));
    }' unless defined(&VOP_DUMP);
    eval 'sub VOP_PATHCONF {
        my($vp, $cmd, $valp, $cr, $ct) = @_;
	    eval q( &fop_pathconf($vp, $cmd, $valp, $cr, $ct));
    }' unless defined(&VOP_PATHCONF);
    eval 'sub VOP_PAGEIO {
        my($vp, $pp, $io_off, $io_len, $flags, $cr, $ct) = @_;
	    eval q( &fop_pageio($vp, $pp, $io_off, $io_len, $flags, $cr, $ct));
    }' unless defined(&VOP_PAGEIO);
    eval 'sub VOP_DUMPCTL {
        my($vp, $action, $blkp, $ct) = @_;
	    eval q( &fop_dumpctl($vp, $action, $blkp, $ct));
    }' unless defined(&VOP_DUMPCTL);
    eval 'sub VOP_DISPOSE {
        my($vp, $pp, $flag, $dn, $cr, $ct) = @_;
	    eval q( &fop_dispose($vp, $pp, $flag, $dn, $cr, $ct));
    }' unless defined(&VOP_DISPOSE);
    eval 'sub VOP_GETSECATTR {
        my($vp, $vsap, $f, $cr, $ct) = @_;
	    eval q( &fop_getsecattr($vp, $vsap, $f, $cr, $ct));
    }' unless defined(&VOP_GETSECATTR);
    eval 'sub VOP_SETSECATTR {
        my($vp, $vsap, $f, $cr, $ct) = @_;
	    eval q( &fop_setsecattr($vp, $vsap, $f, $cr, $ct));
    }' unless defined(&VOP_SETSECATTR);
    eval 'sub VOP_SHRLOCK {
        my($vp, $cmd, $shr, $f, $cr, $ct) = @_;
	    eval q( &fop_shrlock($vp, $cmd, $shr, $f, $cr, $ct));
    }' unless defined(&VOP_SHRLOCK);
    eval 'sub VOP_VNEVENT {
        my($vp, $vnevent, $dvp, $fnm, $ct) = @_;
	    eval q( &fop_vnevent($vp, $vnevent, $dvp, $fnm, $ct));
    }' unless defined(&VOP_VNEVENT);
    eval 'sub VOPNAME_OPEN () {"open";}' unless defined(&VOPNAME_OPEN);
    eval 'sub VOPNAME_CLOSE () {"close";}' unless defined(&VOPNAME_CLOSE);
    eval 'sub VOPNAME_READ () {"read";}' unless defined(&VOPNAME_READ);
    eval 'sub VOPNAME_WRITE () {"write";}' unless defined(&VOPNAME_WRITE);
    eval 'sub VOPNAME_IOCTL () {"ioctl";}' unless defined(&VOPNAME_IOCTL);
    eval 'sub VOPNAME_SETFL () {"setfl";}' unless defined(&VOPNAME_SETFL);
    eval 'sub VOPNAME_GETATTR () {"getattr";}' unless defined(&VOPNAME_GETATTR);
    eval 'sub VOPNAME_SETATTR () {"setattr";}' unless defined(&VOPNAME_SETATTR);
    eval 'sub VOPNAME_ACCESS () {"access";}' unless defined(&VOPNAME_ACCESS);
    eval 'sub VOPNAME_LOOKUP () {"lookup";}' unless defined(&VOPNAME_LOOKUP);
    eval 'sub VOPNAME_CREATE () {"create";}' unless defined(&VOPNAME_CREATE);
    eval 'sub VOPNAME_REMOVE () {"remove";}' unless defined(&VOPNAME_REMOVE);
    eval 'sub VOPNAME_LINK () {"link";}' unless defined(&VOPNAME_LINK);
    eval 'sub VOPNAME_RENAME () {"rename";}' unless defined(&VOPNAME_RENAME);
    eval 'sub VOPNAME_MKDIR () {"mkdir";}' unless defined(&VOPNAME_MKDIR);
    eval 'sub VOPNAME_RMDIR () {"rmdir";}' unless defined(&VOPNAME_RMDIR);
    eval 'sub VOPNAME_READDIR () {"readdir";}' unless defined(&VOPNAME_READDIR);
    eval 'sub VOPNAME_SYMLINK () {"symlink";}' unless defined(&VOPNAME_SYMLINK);
    eval 'sub VOPNAME_READLINK () {"readlink";}' unless defined(&VOPNAME_READLINK);
    eval 'sub VOPNAME_FSYNC () {"fsync";}' unless defined(&VOPNAME_FSYNC);
    eval 'sub VOPNAME_INACTIVE () {"inactive";}' unless defined(&VOPNAME_INACTIVE);
    eval 'sub VOPNAME_FID () {"fid";}' unless defined(&VOPNAME_FID);
    eval 'sub VOPNAME_RWLOCK () {"rwlock";}' unless defined(&VOPNAME_RWLOCK);
    eval 'sub VOPNAME_RWUNLOCK () {"rwunlock";}' unless defined(&VOPNAME_RWUNLOCK);
    eval 'sub VOPNAME_SEEK () {"seek";}' unless defined(&VOPNAME_SEEK);
    eval 'sub VOPNAME_CMP () {"cmp";}' unless defined(&VOPNAME_CMP);
    eval 'sub VOPNAME_FRLOCK () {"frlock";}' unless defined(&VOPNAME_FRLOCK);
    eval 'sub VOPNAME_SPACE () {"space";}' unless defined(&VOPNAME_SPACE);
    eval 'sub VOPNAME_REALVP () {"realvp";}' unless defined(&VOPNAME_REALVP);
    eval 'sub VOPNAME_GETPAGE () {"getpage";}' unless defined(&VOPNAME_GETPAGE);
    eval 'sub VOPNAME_PUTPAGE () {"putpage";}' unless defined(&VOPNAME_PUTPAGE);
    eval 'sub VOPNAME_MAP () {"map";}' unless defined(&VOPNAME_MAP);
    eval 'sub VOPNAME_ADDMAP () {"addmap";}' unless defined(&VOPNAME_ADDMAP);
    eval 'sub VOPNAME_DELMAP () {"delmap";}' unless defined(&VOPNAME_DELMAP);
    eval 'sub VOPNAME_POLL () {"poll";}' unless defined(&VOPNAME_POLL);
    eval 'sub VOPNAME_DUMP () {"dump";}' unless defined(&VOPNAME_DUMP);
    eval 'sub VOPNAME_PATHCONF () {"pathconf";}' unless defined(&VOPNAME_PATHCONF);
    eval 'sub VOPNAME_PAGEIO () {"pageio";}' unless defined(&VOPNAME_PAGEIO);
    eval 'sub VOPNAME_DUMPCTL () {"dumpctl";}' unless defined(&VOPNAME_DUMPCTL);
    eval 'sub VOPNAME_DISPOSE () {"dispose";}' unless defined(&VOPNAME_DISPOSE);
    eval 'sub VOPNAME_GETSECATTR () {"getsecattr";}' unless defined(&VOPNAME_GETSECATTR);
    eval 'sub VOPNAME_SETSECATTR () {"setsecattr";}' unless defined(&VOPNAME_SETSECATTR);
    eval 'sub VOPNAME_SHRLOCK () {"shrlock";}' unless defined(&VOPNAME_SHRLOCK);
    eval 'sub VOPNAME_VNEVENT () {"vnevent";}' unless defined(&VOPNAME_VNEVENT);
    eval 'sub LOOKUP_DIR () {0x1;}' unless defined(&LOOKUP_DIR);
    eval 'sub LOOKUP_XATTR () {0x2;}' unless defined(&LOOKUP_XATTR);
    eval 'sub CREATE_XATTR_DIR () {0x4;}' unless defined(&CREATE_XATTR_DIR);
    eval 'sub LOOKUP_HAVE_SYSATTR_DIR () {0x8;}' unless defined(&LOOKUP_HAVE_SYSATTR_DIR);
    eval 'sub V_RDDIR_ENTFLAGS () {0x1;}' unless defined(&V_RDDIR_ENTFLAGS);
    eval 'sub V_WRITELOCK_TRUE () {(1);}' unless defined(&V_WRITELOCK_TRUE);
    eval 'sub V_WRITELOCK_FALSE () {(0);}' unless defined(&V_WRITELOCK_FALSE);
    eval 'sub DUMP_ALLOC () {0;}' unless defined(&DUMP_ALLOC);
    eval 'sub DUMP_FREE () {1;}' unless defined(&DUMP_FREE);
    eval 'sub DUMP_SCAN () {2;}' unless defined(&DUMP_SCAN);
    if(defined(&_KERNEL)) {
	eval 'sub VN_HOLD {
	    my($vp) = @_;
    	    eval q({  &mutex_enter(($vp)-> &v_lock); ($vp)-> &v_count++;  &mutex_exit(($vp)-> &v_lock); });
	}' unless defined(&VN_HOLD);
	eval 'sub VN_RELE {
	    my($vp) = @_;
    	    eval q({  &vn_rele($vp); });
	}' unless defined(&VN_RELE);
	eval 'sub VN_SET_VFS_TYPE_DEV {
	    my($vp, $vfsp, $type, $dev) = @_;
    	    eval q({ ($vp)-> &v_vfsp = ($vfsp); ($vp)-> &v_type = ($type); ($vp)-> &v_rdev = ($dev); });
	}' unless defined(&VN_SET_VFS_TYPE_DEV);
	eval 'sub VN_CMP {
	    my($VP1, $VP2) = @_;
    	    eval q((($VP1) == ($VP2) ? 1: (($VP1)  && ($VP2)  && ( &vn_getops($VP1) ==  &vn_getops($VP2)) ?  &VOP_CMP($VP1, $VP2,  &NULL) : 0)));
	}' unless defined(&VN_CMP);
	eval 'sub VN_ISKAS {
	    my($vp) = @_;
    	    eval q((($vp) ==  &kvp || ($vp) ==  &zvp));
	}' unless defined(&VN_ISKAS);
    }
    eval 'sub ATTR_UTIME () {0x1;}' unless defined(&ATTR_UTIME);
    eval 'sub ATTR_EXEC () {0x2;}' unless defined(&ATTR_EXEC);
    eval 'sub ATTR_COMM () {0x4;}' unless defined(&ATTR_COMM);
    eval 'sub ATTR_HINT () {0x8;}' unless defined(&ATTR_HINT);
    eval 'sub ATTR_REAL () {0x10;}' unless defined(&ATTR_REAL);
    eval 'sub ATTR_NOACLCHECK () {0x20;}' unless defined(&ATTR_NOACLCHECK);
    eval 'sub ATTR_TRIGGER () {0x40;}' unless defined(&ATTR_TRIGGER);
    eval 'sub VBSIZE {
        my($vp) = @_;
	    eval q((($vp)-> ($v_vfsp->{vfs_bsize})));
    }' unless defined(&VBSIZE);
    eval 'sub VTOZONE {
        my($vp) = @_;
	    eval q((($vp)-> ($v_vfsp->{vfs_zone})));
    }' unless defined(&VTOZONE);
    eval 'sub NULLVP () {(0);}' unless defined(&NULLVP);
    eval 'sub NULLVPP () {(0);}' unless defined(&NULLVPP);
    if(defined(&_KERNEL)) {
	eval 'sub VN_DISPOSE {
	    my($pp, $flag, $dn, $cr) = @_;
    	    eval q({  &extern 1;  &if (($pp)-> &p_vnode !=  &NULL  && ! &VN_ISKAS(($pp)-> &p_vnode))  &VOP_DISPOSE(($pp)-> &p_vnode, ($pp), ($flag), ($dn), ($cr),  &NULL);  &else  &if (($flag) ==  &B_FREE)  &page_free(($pp), ($dn));  &else  &page_destroy(($pp), ($dn)); });
	}' unless defined(&VN_DISPOSE);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
